<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package artist_painter
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function artist_painter_body_classes( $classes ) {
  global $artist_painter_post;
  
    if( !is_page_template( 'template-home.php' ) ){
        $classes[] = 'inner';
        // Adds a class of group-blog to blogs with more than 1 published author.
    }

    if ( is_multi_author() ) {
        $classes[] = 'group-blog ';
    }

    // Adds a class of custom-background-image to sites with a custom background image.
    if ( get_background_image() ) {
        $classes[] = 'custom-background-image';
    }
    
    // Adds a class of custom-background-color to sites with a custom background color.
    if ( get_background_color() != 'ffffff' ) {
        $classes[] = 'custom-background-color';
    }
    

    if( artist_painter_woocommerce_activated() && ( is_shop() || is_product_category() || is_product_tag() || 'product' === get_post_type() ) && ! is_active_sidebar( 'shop-sidebar' ) ){
        $classes[] = 'full-width';
    }    

    // Adds a class of hfeed to non-singular pages.
    if ( ! is_page() ) {
        $classes[] = 'hfeed ';
    }
  
    if( is_404() ||  is_search() ){
        $classes[] = 'full-width';
    }
  
    if( ! is_active_sidebar( 'right-sidebar' ) ) {
        $classes[] = 'full-width'; 
    }

    return $classes;
}
add_filter( 'body_class', 'artist_painter_body_classes' );

 /**
 * 
 * @link http://www.altafweb.com/2011/12/remove-specific-tag-from-php-string.html
 */
function artist_painter_strip_single( $tag, $string ){
    $string=preg_replace('/<'.$tag.'[^>]*>/i', '', $string);
    $string=preg_replace('/<\/'.$tag.'>/i', '', $string);
    return $string;
}

if ( ! function_exists( 'artist_painter_excerpt_more' ) ) :
/**
 * Replaces "[...]" (appended to automatically generated excerpts) with ... * 
 */
function artist_painter_excerpt_more($more) {
  return is_admin() ? $more : ' &hellip; ';
}
endif;
add_filter( 'excerpt_more', 'artist_painter_excerpt_more' );


if( ! function_exists( 'artist_painter_footer_credit' ) ):
/**
 * Footer Credits
*/
function artist_painter_footer_credit() {

    // Check if footer copyright is enabled
    $artist_painter_show_footer_copyright = get_theme_mod( 'artist_painter_footer_setting', true );

    if ( ! $artist_painter_show_footer_copyright ) {
        return; 
    }

    $artist_painter_copyright_text = get_theme_mod('artist_painter_footer_copyright_text');

    $artist_painter_text = '<div class="site-info"><div class="container"><span class="copyright">';
    if ($artist_painter_copyright_text) {
        $artist_painter_text .= wp_kses_post($artist_painter_copyright_text); 
    } else {
        $artist_painter_text .= esc_html__('&copy; ', 'artist-painter') . date_i18n(esc_html__('Y', 'artist-painter')); 
        $artist_painter_text .= ' <a href="' . esc_url(home_url('/')) . '">' . esc_html(get_bloginfo('name')) . '</a>' . esc_html__('. All Rights Reserved.', 'artist-painter');
    }
    $artist_painter_text .= '</span>';
    $artist_painter_text .= '<span class="by"> <a href="' . esc_url('https://www.themeignite.com/products/artist-painter') . '" rel="nofollow" target="_blank">' . ARTIST_PAINTER_THEME_NAME . '</a>' . esc_html__(' By ', 'artist-painter') . '<a href="' . esc_url('https://themeignite.com/') . '" rel="nofollow" target="_blank">' . esc_html__('Themeignite', 'artist-painter') . '</a>.';
    /* translators: %s: link to WordPress.org */
    $artist_painter_text .= sprintf(esc_html__(' Powered By %s', 'artist-painter'), '<a href="' . esc_url(__('https://wordpress.org/', 'artist-painter')) . '" target="_blank">WordPress</a>.');
    if (function_exists('the_privacy_policy_link')) {
        $artist_painter_text .= get_the_privacy_policy_link();
    }
    $artist_painter_text .= '</span></div></div>';
    echo apply_filters('artist_painter_footer_text', $artist_painter_text);
}
add_action('artist_painter_footer', 'artist_painter_footer_credit');
endif;

/**
 * Is Woocommerce activated
*/
if ( ! function_exists( 'artist_painter_woocommerce_activated' ) ) {
  function artist_painter_woocommerce_activated() {
    if ( class_exists( 'woocommerce' ) ) { return true; } else { return false; }
  }
}

if( ! function_exists( 'artist_painter_change_comment_form_default_fields' ) ) :
/**
 * Change Comment form default fields i.e. author, email & url.
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function artist_painter_change_comment_form_default_fields( $fields ){    
    // get the current commenter if available
    $artist_painter_commenter = wp_get_current_commenter();
 
    // core functionality
    $req      = get_option( 'require_name_email' );
    $artist_painter_aria_req = ( $req ? " aria-required='true'" : '' );
    $artist_painter_required = ( $req ? " required" : '' );
    $artist_painter_author   = ( $req ? __( 'Name*', 'artist-painter' ) : __( 'Name', 'artist-painter' ) );
    $artist_painter_email    = ( $req ? __( 'Email*', 'artist-painter' ) : __( 'Email', 'artist-painter' ) );
 
    // Change just the author field
    $fields['author'] = '<p class="comment-form-author"><label class="screen-reader-text" for="author">' . esc_html__( 'Name', 'artist-painter' ) . '<span class="required">*</span></label><input id="author" name="author" placeholder="' . esc_attr( $artist_painter_author ) . '" type="text" value="' . esc_attr( $artist_painter_commenter['comment_author'] ) . '" size="30"' . $artist_painter_aria_req . $artist_painter_required . ' /></p>';
    
    $fields['email'] = '<p class="comment-form-email"><label class="screen-reader-text" for="email">' . esc_html__( 'Email', 'artist-painter' ) . '<span class="required">*</span></label><input id="email" name="email" placeholder="' . esc_attr( $artist_painter_email ) . '" type="text" value="' . esc_attr(  $artist_painter_commenter['comment_author_email'] ) . '" size="30"' . $artist_painter_aria_req . $artist_painter_required. ' /></p>';
    
    $fields['url'] = '<p class="comment-form-url"><label class="screen-reader-text" for="url">' . esc_html__( 'Website', 'artist-painter' ) . '</label><input id="url" name="url" placeholder="' . esc_attr__( 'Website', 'artist-painter' ) . '" type="text" value="' . esc_attr( $artist_painter_commenter['comment_author_url'] ) . '" size="30" /></p>'; 
    
    return $fields;    
}
endif;
add_filter( 'comment_form_default_fields', 'artist_painter_change_comment_form_default_fields' );

if( ! function_exists( 'artist_painter_change_comment_form_defaults' ) ) :
/**
 * Change Comment Form defaults
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function artist_painter_change_comment_form_defaults( $defaults ){    
    $defaults['comment_field'] = '<p class="comment-form-comment"><label class="screen-reader-text" for="comment">' . esc_html__( 'Comment', 'artist-painter' ) . '</label><textarea id="comment" name="comment" placeholder="' . esc_attr__( 'Comment', 'artist-painter' ) . '" cols="45" rows="8" aria-required="true" required></textarea></p>';
    
    return $defaults;    
}
endif;
add_filter( 'comment_form_defaults', 'artist_painter_change_comment_form_defaults' );

if( ! function_exists( 'artist_painter_escape_text_tags' ) ) :
/**
 * Remove new line tags from string
 *
 * @param $text
 * @return string
 */
function artist_painter_escape_text_tags( $text ) {
    return (string) str_replace( array( "\r", "\n" ), '', strip_tags( $text ) );
}
endif;

if( ! function_exists( 'wp_body_open' ) ) :
/**
 * Fire the wp_body_open action.
 * Added for backwards compatibility to support pre 5.2.0 WordPress versions.
*/
function wp_body_open() {
    /**
     * Triggered after the opening <body> tag.
    */
    do_action( 'wp_body_open' );
}
endif;

if ( ! function_exists( 'artist_painter_get_fallback_svg' ) ) :    
/**
 * Get Fallback SVG
*/
function artist_painter_get_fallback_svg( $artist_painter_post_thumbnail ) {
    if( ! $artist_painter_post_thumbnail ){
        return;
    }
    
    $artist_painter_image_size = artist_painter_get_image_sizes( $artist_painter_post_thumbnail );
     
    if( $artist_painter_image_size ){ ?>
        <div class="svg-holder">
             <svg class="fallback-svg" viewBox="0 0 <?php echo esc_attr( $artist_painter_image_size['width'] ); ?> <?php echo esc_attr( $artist_painter_image_size['height'] ); ?>" preserveAspectRatio="none">
                    <rect width="<?php echo esc_attr( $artist_painter_image_size['width'] ); ?>" height="<?php echo esc_attr( $artist_painter_image_size['height'] ); ?>" style="fill:#dedddd;"></rect>
            </svg>
        </div>
        <?php
    }
}
endif;

function artist_painter_enqueue_google_fonts() {

    require get_template_directory() . '/inc/wptt-webfont-loader.php';

    wp_enqueue_style(
        'google-fonts-roboto',
        artist_painter_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Roboto:ital,wght@0,100..900;1,100..900&display=swap' ),
        array(),
        '1.0'
    );

    wp_enqueue_style(
        'google-fonts-kalam',
        artist_painter_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Kalam:wght@300;400;700&display=swap' ),
        array(),
        '1.0'
    );
}
add_action( 'wp_enqueue_scripts', 'artist_painter_enqueue_google_fonts' );


if( ! function_exists( 'artist_painter_site_branding' ) ) :
/**
 * Site Branding
*/
function artist_painter_site_branding(){
    $artist_painter_logo_site_title = get_theme_mod( 'header_site_title', 0 );
    $artist_painter_tagline = get_theme_mod( 'header_tagline', false );
    $artist_painter_logo_width = get_theme_mod('logo_width', 70); // Retrieve the logo width setting

    ?>
    <div class="site-branding" style="max-width: <?php echo esc_attr(get_theme_mod('logo_width', '-1'))?>px;">
        <?php 
        // Check if custom logo is set and display it
        if (function_exists('has_custom_logo') && has_custom_logo()) {
            the_custom_logo();
        }
        if ($artist_painter_logo_site_title):
             if (is_front_page()): ?>
            <h1 class="site-title" style="font-size: <?php echo esc_attr(get_theme_mod('artist_painter_site_title_size', '20')); ?>px;">
            <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
          </h1>
            <?php else: ?>
                <p class="site-title" itemprop="name">
                    <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
                </p>
            <?php endif; ?>
        <?php endif; 
    
        if ($artist_painter_tagline) :
            $artist_painter_description = get_bloginfo('description', 'display');
            if ($artist_painter_description || is_customize_preview()) :
        ?>
                <p class="site-description" itemprop="description"><?php echo $artist_painter_description; ?></p>
            <?php endif;
        endif;
        ?>
    </div>
    <?php
}
endif;
if( ! function_exists( 'artist_painter_navigation' ) ) :
    /**
     * Site Navigation
    */
    function artist_painter_navigation(){
        ?>
        <nav class="main-navigation" id="site-navigation" role="navigation">
            <?php 
            wp_nav_menu( array( 
                'theme_location' => 'primary', 
                'menu_id' => 'primary-menu' 
            ) ); 
            ?>
        </nav>
        <?php
    }
endif;

if( ! function_exists( 'artist_painter_header' ) ) :
    /**
     * Header Start
    */
    function artist_painter_header(){
        $artist_painter_header_image = get_header_image();
        $artist_painter_sticky_header = get_theme_mod('artist_painter_sticky_header');
        $artist_painter_social_icon = get_theme_mod( 'artist_painter_social_icon_setting', false);
        $artist_painter_header_setting     = get_theme_mod( 'artist_painter_header_setting', false );
        ?>
        <div id="page-site-header" class="main-header">
            <header id="masthead" class="site-header header-inner" role="banner">
                <div class="topbar">
                    <div class="container">
                        <div class="row pt-4 pb-2 top-head">
                            <div class="col-xl-3 col-lg-3 col-md-3 col-sm-3 col-12 align-self-center text-md-start header-detail">
                                <?php artist_painter_site_branding(); ?>
                            </div>
                            <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12 align-self-center">
                            <?php if ( $artist_painter_social_icon ){?>
                                    <div class="social-links">
                                        <?php 
                                        $artist_painter_social_link1 = get_theme_mod( 'artist_painter_social_link_1' );
                                        $artist_painter_social_link2 = get_theme_mod( 'artist_painter_social_link_2' );
                                        $artist_painter_social_link3 = get_theme_mod( 'artist_painter_social_link_3' );
                                        $artist_painter_social_link4 = get_theme_mod( 'artist_painter_social_link_4' );
                                        $artist_painter_social_link5 = get_theme_mod( 'artist_painter_social_link_5' );
                                        if ( ! empty( $artist_painter_social_link1 ) ) {
                                            echo '<a class="social1" href="' . esc_url( $artist_painter_social_link1 ) . '" target="_blank"><i class="fab fa-facebook"></i></a>';
                                        }
                                        if ( ! empty( $artist_painter_social_link3 ) ) {
                                            echo '<a class="social3" href="' . esc_url( $artist_painter_social_link3 ) . '" target="_blank"><i class="fab fa-instagram-square"></i></a>';
                                        }
                                        if ( ! empty( $artist_painter_social_link2 ) ) {
                                            echo '<a class="social2" href="' . esc_url( $artist_painter_social_link2 ) . '" target="_blank"><i class="fab fa-twitter-square"></i></a>';
                                        } 
                                        if ( ! empty( $artist_painter_social_link5 ) ) {
                                            echo '<a class="social2" href="' . esc_url( $artist_painter_social_link5 ) . '" target="_blank"><i class="fab fa-youtube-square"></i></a>';
                                        } 
                                        if ( ! empty( $artist_painter_social_link4 ) ) {
                                            echo '<a class="social4" href="' . esc_url( $artist_painter_social_link4 ) . '" target="_blank"><i class="fab fa-pinterest"></i></a>';
                                        }
                                        ?>
                                    </div>
                                <?php } ?>  
                            </div>
                            <div class="col-xl-3 col-lg-3 col-md-3 col-sm-3 col-12 align-self-center account">
                                <?php if (get_theme_mod('artist_painter_wishlist_url') != "") { ?>
                                    <span class="wish-btn">
                                        <a href="<?php echo esc_url(get_theme_mod('artist_painter_wishlist_url')); ?>">
                                            <i class="far fa-heart"></i>
                                        </a>
                                    </span>
                                <?php } ?>
                                <?php if (class_exists('woocommerce')) { ?>
                                    <span class="cart-count">
                                        <a class="cart-customlocation" href="<?php if (function_exists('wc_get_cart_url')) { echo esc_url(wc_get_cart_url()); } ?>" title="<?php esc_attr_e('View Shopping Cart', 'artist-painter'); ?>">
                                            <i class="fas fa-shopping-cart"></i>
                                            <span class="cart-item-box"><?php echo esc_html(wp_kses_data(WC()->cart->get_cart_contents_count())); ?></span>
                                        </a>
                                    </span>
                                <?php } ?>
                                <?php if (class_exists('woocommerce')) { ?>
                                    <span class="user-btn">
                                        <?php if (is_user_logged_in()) { ?>
                                            <a class="account-btn" href="<?php echo esc_url(get_permalink(get_option('woocommerce_myaccount_page_id'))); ?>" title="<?php esc_attr_e('My Account','artist-painter'); ?>">
                                                <i class="fas fa-user-circle"></i>
                                            </a>
                                        <?php } else { ?>
                                            <a class="account-btn" href="<?php echo esc_url(get_permalink(get_option('woocommerce_myaccount_page_id'))); ?>" title="<?php esc_attr_e('My Account','artist-painter'); ?>"></a>
                                        <?php } ?>
                                    </span>
                                <?php } ?>

                            </div>
                        </div>
                    </div>
                </div>
                <div class="theme-menu head_bg" <?php echo $artist_painter_header_image != '' ? 'style="background-image: url(' . esc_url( $artist_painter_header_image ) . '); background-repeat: no-repeat; background-size: cover"': ""; ?> data-sticky="<?php echo esc_attr( $artist_painter_sticky_header ); ?>">
                        <div class="container">
                            <div class="row">
                                <div class="col-8">
                                    <div class="menu-bg py-2">
                                        <?php artist_painter_navigation(); ?> 
                                    </div>
                                </div>
                            </div>
                        </div>
                </div>                   
            </header>
        </div>
        <?php
    }
endif;
add_action( 'artist_painter_header', 'artist_painter_header', 20 );
